var ppsoptions = {
	
	prefManager: null,
	countrylist: {},
	portlist: {},
	
	$: function(id){
		return document.getElementById(id);
	},
	
	onLoad: function(){
		this.prefManager = Components.classes["@mozilla.org/preferences-service;1"]
									 .getService(Components.interfaces.nsIPrefBranch);
	
		var rawCountryPortList = this.prefManager.getCharPref('extensions.premiumproxyswitcher.serverportoptions').split('||');
		var countryList = rawCountryPortList[0].split('|');
		var portList = rawCountryPortList[1].split('|');
			
		for(var i in countryList) {
			rawCountry = countryList[i].split('=');
			this.countrylist[rawCountry[0]] = rawCountry[1];
		}
		for(var i in portList) {
			rawPort = portList[i].split('=');
			this.portlist[rawPort[0]] = rawPort[1];
		}

		this.initServerPortSelector('comp-optcountry', this.countrylist, this.prefManager.getCharPref('extensions.premiumproxyswitcher.optcountry'));
		this.initServerPortSelector('comp-optport', this.portlist, this.prefManager.getCharPref('extensions.premiumproxyswitcher.optport'));
		
		this.onAutoCheckboxChange();
		this.onAutoChangeCheckboxChange();
	},
	
	onAccept: function(){
		if(this.$('comp-site').getAttribute('selected') == 'true'){
			if(this.$('comp-optauto').getAttribute('checked') == 'true'){
				var value = parseInt(this.$('comp-optinterval').value);
				if(value == null || value == NaN || value < 1 || value > 60){
					alert(this.getPropertyString('downloadInterval'));
					return false;
				}
			}
			
			if(this.$('comp-optautochange').getAttribute('checked') == 'true'){
				var value = parseInt(this.$('comp-optintervalchange').value);
				if(value == null || value == NaN || value < 1 || value > 60){
					alert(this.getPropertyString('changeInterval'));
					return false;
				}
			}
		}else{
			var url = this.$('comp-optcustomizeurl').value;
			if(url == ''){
				alert(this.getPropertyString('validCustomUrl'));
				return false;
			}
		}
		this.prefManager.setCharPref('extensions.premiumproxyswitcher.optcountry', this.$('comp-optcountry').value);
		this.prefManager.setCharPref('extensions.premiumproxyswitcher.optport', this.$('comp-optport').value);
		this.prefManager.setCharPref('extensions.premiumproxyswitcher.opttype', this.$('comp-opttype').value);
		this.prefManager.setCharPref('extensions.premiumproxyswitcher.optssl', this.$('comp-optssl').value);
		this.prefManager.setCharPref('extensions.premiumproxyswitcher.optconnect', this.$('comp-optconnect').value);
		this.prefManager.setCharPref('extensions.premiumproxyswitcher.optpostget', this.$('comp-optpostget').value);
		this.prefManager.setIntPref('extensions.premiumproxyswitcher.optminspeed', this.$('comp-optminspeed').value);
		this.prefManager.setIntPref('extensions.premiumproxyswitcher.optmaxping', this.$('comp-optmaxping').value);
		this.prefManager.setIntPref('extensions.premiumproxyswitcher.optminuptime', this.$('comp-optminuptime').value);
		this.prefManager.setIntPref('extensions.premiumproxyswitcher.optproxyinterval', this.$('comp-optproxyinterval').value);
		this.prefManager.setIntPref('extensions.premiumproxyswitcher.optinterval', this.$('comp-optinterval').value);
		this.prefManager.setIntPref('extensions.premiumproxyswitcher.optintervalchange', this.$('comp-optintervalchange').value);
		this.prefManager.setCharPref('extensions.premiumproxyswitcher.optvip', this.$('comp-optvip').value);
		this.prefManager.setCharPref('extensions.premiumproxyswitcher.optcustomizeurl', this.$('comp-optcustomizeurl').value);
		this.prefManager.setBoolPref('extensions.premiumproxyswitcher.optauto', this.$('comp-optauto').checked);
		this.prefManager.setBoolPref('extensions.premiumproxyswitcher.optautochange', this.$('comp-optautochange').checked);
		this.prefManager.setBoolPref('extensions.premiumproxyswitcher.optuseservice', this.$('comp-site').getAttribute('selected') == 'true');
		
		opener.premiumproxyswitcher.updateConfiguration = true;
		
		return true;
	},
	
	initServerPortSelector: function(_id, _opts, value){
		var menu = this.$(_id);
		for(var j=menu.itemCount-1;j>=0;j--){
			menu.removeItemAt(j);
		}
		
		var index = 0;
		var selectedIndex = 0;
		for(var i in _opts){
			var p = _opts[i];
			var oItem = menu.appendItem(p, i);
			if(value == i){
				selectedIndex = index;
			}
			index++;
		}
		
		menu.selectedIndex = selectedIndex;
	},
	
	onAutoCheckboxChange: function(){
		if(this.$('comp-optauto').checked){
			this.$('comp-optinterval').removeAttribute('disabled');
		}else{
			this.$('comp-optinterval').setAttribute('disabled', true);
		}
	},
	
	onAutoChangeCheckboxChange: function(){
		if(this.$('comp-optautochange').checked){
			this.$('comp-optintervalchange').removeAttribute('disabled');
		}else{
			this.$('comp-optintervalchange').setAttribute('disabled', true);
		}
	},
	
	openBuyVipCode: function() {
		window.open(this.getPropertyString('buyvipcodeurl'));
	},
	
	getPropertyString: function(name){
		try{
			if (this.propertiesBundle == null){
				var oBundle	= Components.classes['@mozilla.org/intl/stringbundle;1']
										.getService(Components.interfaces.nsIStringBundleService);
				this.propertiesBundle = oBundle.createBundle('chrome://premiumproxyswitcher/locale/premiumproxyswitcher.properties');
			}
			return this.propertiesBundle.GetStringFromName(name);
		}catch(err){}
	
		return name;
	}
	
};

window.addEventListener("load", function(e) { ppsoptions.onLoad(e); }, false);